/*
        Mojodo Project Code (c)
        Project: Socket Raw Library
        Coders: ValK
        thxto: Harada
*/

#include <stdio.h>
#include <stdlib.h>

//#include <netdb.h>
//#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <net/if.h>
#include <net/if_arp.h>
/* v6 Header */
#include <netinet/ip6.h>
#include <netinet/icmp6.h>

#include <linux/sockios.h>
#include <linux/if_ether.h>

#define __GNU_SOURCE
#define LIBVERSION "2.1"
#define MTU 1500
#define NODATA ""

/*#define DEBUG*/

const        char    libinfo[]="Mojodo Project Code ,no (c) 2002";
const        char    liblink[]="Avatar Corp. ,no (c) 2002";
const        char    license[]="GNU/GPL";
const        int     TCP_MAXDATALEN=(MTU-sizeof(struct tcphdr)) - sizeof(struct iphdr);
const        int     ICMP_MAXDATALEN=(MTU-sizeof(struct icmphdr)) - sizeof(struct iphdr);
const        int     UDP_MAXDATALEN=(MTU-sizeof(struct udphdr)) - sizeof(struct iphdr);
const        int     TCP6_MAXDATALEN=(MTU-sizeof(struct tcphdr)) - sizeof(struct ip6_hdr);
const        int     ICMP6_MAXDATALEN=(MTU-sizeof(struct icmp6_hdr)) - sizeof(struct ip6_hdr);
const        int     UDP6_MAXDATALEN=(MTU-sizeof(struct udphdr)) - sizeof(struct ip6_hdr);

struct ls_v6opt {
	int flow_label,
	    hop_limit,
	    vfc;
	char device[10];
	};

struct ls_settings
        {
        int        seq,
                ack_seq,
                window,
                urg_ptr;
        };

struct ls_tcpflags
{
        int        doff,
                res1,
                res2,
                urg,
                ack,
                psh,
                rst,
                syn,
                fin;
};

struct ls_icmp6 {
	u_int8_t  type,
	          code;
	u_int16_t id,
                  seq;
	int       pptr,
	          mtu;
};
struct ls_ip {
    u_int8_t tos;
    u_int16_t id;
    u_int16_t frag_off;
    u_int8_t ttl;
};

struct pseudoIP
{
        unsigned long int source, dest;
        char zero_byte, protocol;
        unsigned short len;
};
struct pseudoIP6 {
	struct in6_addr src;
	struct in6_addr dst;
	uint32_t ulpl;
	uint32_t zero_nxt;
};

/**[-ARP by Lupsyn-]***********************************/
struct ls_arp
{
        u_char Dst_e_hw[ETH_ALEN];
        u_char Src_e_hw[ETH_ALEN];
        u_short frame_type;
        u_short hw_type;
        u_short prot_type;
        u_char hw_addr_size;
        u_char prot_addr_size;
        u_short op;
        u_char Src_a_hw[ETH_ALEN];
        u_char Src_a_ip[4];
        u_char Dst_a_hw[ETH_ALEN];
        u_char Dst_a_ip[4];
};
/****************************************************/

struct sockaddr_in sockfd;

int sock;

/* Vari Prototipi */
in_addr_t inet_addr(const char *cp);
int inet_pton(int af, const char *src, void *dst);
int close(int fd);

char *libversion();
int ls_socket(char *dstHost);
int ls_sendtcp(struct ls_ip *ip4,char *srcHost,char *dstHost,int sport, int dport,unsigned char *data, int binlen , struct ls_tcpflags flags, struct ls_settings settings);
int ls_sendicmp(struct ls_ip *ip4,char *srcHost,char *dstHost, u_int8_t type, u_int8_t code,unsigned char *data, int binlen);
int ls_sendudp(struct ls_ip *ip4,char *srcHost,char *dstHost,int sport, int dport,unsigned char *data, int binlen);

/* v6 Funcion */
int ls_socket6(char *dstHost, char *device);
int ls_sendudp6(char *srcHost,char *dstHost,int sport, int dport,unsigned char *data, int binlen,struct ls_v6opt option);
int ls_sendtcp6(char *srcHost,char *dstHost,int sport, int dport,unsigned char *data, int binlen, struct ls_tcpflags flags, struct ls_settings settings, struct ls_v6opt option);
int ls_sendicmp6(char *srcHost,char *dstHost,struct ls_icmp6 icmpinfo,unsigned char *data, int binlen, struct ls_v6opt option);
void setiphdr6(struct ip6_hdr *ip6, int iplen, int protocol,char *srcHost, char *dstHost,int frag, int datalen,struct ls_v6opt option);

/* ARP by Lupsyn */
void die(char* str);
void ls_sendarp(struct ls_arp pkt, char *dev);
int getdevindex(int sock, char *name);


void setiphdr(struct iphdr *ip,struct ls_ip *ip4, int iplen, int protocol,char *srcHost, char *dstHost,int frag, int datalen);
unsigned short in_cksum(unsigned short *addr,register unsigned int len,int csum);
